'''
SM204 Map Idea Generator
Code by ZungryWare
'''

import random

printmode = 2
options = 1
#Green text
if printmode == 0:
    col = '\033[92m'
    end = '\033[0m'
    #Print header text
    print("=========================")
    print("SM205 Map Idea Generator:")
    print("=========================\n")
elif printmode == 1:
    col = "**"
    end = "**"
else:
    col = ""
    end = ""
    #Print header text
    print("=========================")
    print("SM205 Map Idea Generator:")
    print("=========================\n")

def bold(str_in):
    return col + str(str_in) + end

#Picks an item from the include list, print it, then remove it so it can't be printed again
def pick_include(incl):
    rand = random.randint(0,len(incl)-1)
    print(bold(str(incl[rand][1])) + " instances of " + bold(incl[rand][0]))
    del incl[rand]
    
#Picks an item from the requirement list and prints it
def pick_requirement(reqs):
    rand = random.randint(0,len(reqs)-1)
    print(bold(reqs[rand]) + "\n")

#Picks two different themes from the themes list and prints them
def pick_theme(theme):
    rand1 = random.randint(0,len(theme)-1)
    print("Your map must be of theme " + bold(theme[rand1]))

def cycle():
    #List of entities the mapper must include
    incl = [
        ["monster_tarbaby", 6],
        ["monster_shambler", 3],
        ["monster_shalrath", 4],
        ["monster_ogre", 8],
        ["monster_fish", 8],
        ["monster_dog", 12],
        ["monster_enforcer", 10],
        ["monster_demon1", 6],
        ["monster_wizard", 8],
        ["monster_zombie", 10],
        ["trigger_push", 5],
        ["trigger_teleport", 5],
        ["trigger_monsterjump", 6],
        ["trigger_counter", 4],
        ["trigger_secret", 7],
        ["func_button", 12],
        ["func_train", 4],
        ["func_plat", 7],
        ["func_illusionary", 6],
        ["misc_fireball", 8],
        ["misc_explobox/misc_explobox2", 8],
        ["misc_teleporttrain", 1],
        ["trap_shooter/trap_spikeshooter", 10],
        ["item_armorInv", 3],
        ["item_artifact_super_damage", 2],
        ["item_artifact_invulnerability", 2],
        ["item_artifact_invisibility", 2],
        ["item_artifact_envirosuit", 2],
        ["weapon_rocketlauncher", 1],
    ]
    #List of themes
    theme = [
        "Tech/Base",
        "Medieval/Elder",
        "Runic/Metal",
    ]
    #List of misc. requirements
    reqs = [
        "Your level may not have any item_health entities.",
        "Your level must have some sort of puzzle in it.",
        "Your level must have at least 3 pools of lava.",
        "Your level's exit must be next to the start point.",
        "Your level must have at least one of every\nmonster. (Except Cthon and Shub-Niggurath)",
        "Your level may only have two monster types.",
        "Your level must involve the player climbing up the\nmap a distance of 1500 units or more.",
        "Your level must have some platforming in it.",
        "Your level should be shaped like something when\nviewed from above or from a certain angle. (Like e3m2 from Doom.)",
        "Your level must use switchable lights somehow.",
        "Your level must be playable in both Singleplayer and Deathmatch",
        #These ones have been done recently, so I'm commenting them out for now
        #"The playable area of your level must fit within a 768x768 horizontal area. It can be as tall as you wish.", 
        #"The playable area of your level must fit within a 1024x1024x1024 volume.", 
        #"You are limited to only six textures.",
        #"You may only use 100 brushes.",
        #"All vertices of your world geometry must be on a 64 unit grid size.",
    ]
    
    req = random.randint(0,1)

    #Print inclusion requirements
    print("Your level must include at least:")
    pick_include(incl);
    pick_include(incl);
    if req != 0:
        pick_include(incl);
        pick_include(incl);
    print("on skill 0. (Higher skills may have more.)\n")

    if req == 0:
        pick_requirement(reqs)

    #pick_theme(theme)

def main():
    count = 1
    while count <= options:
        if options > 1:
            print("========")
            print("Option " + str(count))
            print("========\n")
        cycle()
        count += 1

main()
    